//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package nc.bs.arap.actions;

import nc.bs.arap.bill.ArapBillPubUtil;
import nc.bs.arap.util.ArapBillVOUtils;
import nc.bs.arap.util.BillAccountCalendarUtils;
import nc.bs.arap.util.BillDateUtils;
import nc.bs.arap.validator.CrossRuleCheckValidator;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.trade.business.HYSuperDMO;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.arap.basebill.BaseBillVO;
import nc.vo.arap.gathering.GatheringBillItemVO;
import nc.vo.arap.utils.StringUtil;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.lang.UFDouble;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GatheringbillEditSaveBatchBSAction extends BillUpdateBatchBSAction {
	public GatheringbillEditSaveBatchBSAction() {
		this.validatorCode.add(5);
		this.validatorCode.add(34);
		this.validatorCode.add(57);
		this.validatorCode.add(59);
		this.validatorCode.add(62);
		this.validatorCode.add(93);
		this.validatorCode.add(94);
		this.validatorCode.add(100);
		this.validatorCode.remove(44);
	}

	protected void doBeforeUpdate(AggregatedValueObject[] bills, AggregatedValueObject[] orginBills)
			throws BusinessException {
		ArapBillPubUtil.fillTradeTypeInfo(bills);

		for (AggregatedValueObject bill : bills) {
			ArapBillPubUtil.processMoneyOnlySum(bill);
		}

		/**
		 * 收款单保存校验关联的销售订单实际收款金额是否超过价税合计
		 */
		int i = 0;

		for (AggregatedValueObject bill : bills) {
			AggregatedValueObject oriBill = orginBills[i++];
			BaseBillVO billVO = (BaseBillVO) bill.getParentVO(); // 修改的收款单
			BaseBillVO billOriVO = (BaseBillVO) oriBill.getParentVO(); // 之前的收款单
			UFDouble money = billVO.getMoney(); // 修改后的金额
			UFDouble oriMoney = billOriVO.getMoney(); // 修改前的金额
			String pk_tradetype = billVO.getPk_tradetype();
//			if (!"F2-Cxx-02".equals(pk_tradetype)) {
//				continue;
//			}
			String srcBilltype = ((GatheringBillItemVO)bill.getChildrenVO()[0]).getSrc_billtype();
			if(!"30".equals(srcBilltype)){
				continue;
			}

			String def3 = ((GatheringBillItemVO)bill.getChildrenVO()[0]).getSrc_billid(); // 收款单对应的销售订单id
			if (StringUtil.isEmpty(def3) || "N".equals(def3) || "~".equals(def3)) {
				// 无绑定的销售订单则下一次循环
				continue;
			}
			List<String> def3List = new ArrayList<>();
			for (int j=0;j<bill.getChildrenVO().length;i++){
				def3List.add(((GatheringBillItemVO)bill.getChildrenVO()[j]).getSrc_billid());
			}
			String result = "";
			StringBuilder sb = new StringBuilder();
			if (def3List.size() > 1) {
				for (int j = 0; j < def3List.size(); j++) {
					sb.append("'").append(def3List.get(j)).append("'");
					if (j < def3List.size() - 1) {
						sb.append(",");
					}
				}

				result = sb.toString();
			} else {
				result = "'" + (String) def3List.get(0) + "'";
			}
			// 计算收款单金额差值
			UFDouble changeMoney = money.sub(oriMoney);
			// 根据销售订单id去查询销售订单
			BaseDAO dao = new BaseDAO();
//			List<String> defMap = checkOrgCtrl();
//			if (defMap.isEmpty() ) {
//				return ;
//			}
			String sql1="SELECT org_salesorg.CODE ,so_saleorder.dbilldate, so_saleorder.pk_org, so_saleorder.vbillcode,so_saleorder.nreceivedmny,so_saleorder.ntotalorigmny FROM  so_saleorder LEFT JOIN org_salesorg ON org_salesorg.PK_SALESORG = so_saleorder.PK_ORG  where so_saleorder.dr = 0 and so_saleorder.csaleorderid in  (" + result + ") ";
			ArrayList<HashMap<String, Object>> saleMap = (ArrayList<HashMap<String, Object>>)dao.executeQuery(sql1, new MapListProcessor());

//            List<Map> saleMap = (List<Map>)dao.executeQuery(sql1, new MapProcessor());
//            String code = saleMap.get("code").toString();
//            LocalDateTime dbilldate = LocalDateTime.parse(saleMap.get("dbilldate").toString(),
//                    DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
//            LocalDateTime targetDate = LocalDateTime.parse("2025-06-27 00:00:00",
//                    DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
//
//            if (!defMap.isEmpty()&& defMap.contains(code) && dbilldate.isBefore(targetDate)) {
//                return;
//            }
//            Map saleMap = (Map)dao.executeQuery(sql, new MapProcessor());
			//销售订单价税合计
			UFDouble ntotalorigmny = UFDouble.ZERO_DBL;
			//销售订单实际收款金额
			UFDouble nreceivedmny = UFDouble.ZERO_DBL;
			StringBuilder vbillcodeBuilder = new StringBuilder();
			if(saleMap != null) {
				for (Map<String, Object> map : saleMap) {
					// 累加 nreceivedmny
					String nreceivedmnyStr = map.get("nreceivedmny") == null ? "0" : map.get("nreceivedmny").toString();
					nreceivedmny.add(new UFDouble(nreceivedmnyStr)) ;

					// 累加 ntotalorigmny
					BigDecimal ntotalorigmnyStr = map.get("ntotalorigmny") == null ? BigDecimal.ZERO : (BigDecimal) map.get("ntotalorigmny");
					UFDouble ufd=    new UFDouble(ntotalorigmnyStr);
					ntotalorigmny=  ntotalorigmny.add(ufd);
					// 拼接 vbillcode
					String vbillcodeStr = map.get("vbillcode") == null ? "" : map.get("vbillcode").toString();
					if (!vbillcodeStr.isEmpty()) {
						if (vbillcodeBuilder.length() > 0) {
							vbillcodeBuilder.append(", ");
						}
						vbillcodeBuilder.append(vbillcodeStr);
					}
				}
			}
			if (money.compareTo(ntotalorigmny) > 0) {
				UFDouble moreMoney = money.sub(ntotalorigmny);
				throw new BusinessException("【该笔收款税收合计" + money + "已超销售订单 [" + vbillcodeBuilder + "] " + moreMoney + "元，无法传输！请检查订单累计收款金额！】");
			}
		}

		ArapBillVOUtils.prepareDefaultInfo(bills, true);
		BillDateUtils.setBillDateByNow(bills);
		int updateType = this.getUpdateType(bills, orginBills);

		for (AggregatedValueObject bill : bills) {
			bill.getParentVO().setStatus(1);
		}

		if (updateType == TEMP_2_SAVE || updateType == SAVE_2_SAVE) {
			for (AggregatedValueObject bill : bills) {
				for (CircularlyAccessibleValueObject item : bill.getChildrenVO()) {
					if (item.getStatus() != 2 && item.getStatus() != 3) {
						item.setStatus(1);
					}
				}
			}
		}

		if (updateType == TEMP_2_SAVE || updateType == SAVE_2_SAVE) {
			BillAccountCalendarUtils.setAccperiodYearMonth(bills);
		}

		this.checkIsCorrdBillMoneyControl(bills, orginBills);
		this.checkOtherSystemBill(bills, orginBills);
		(new CrossRuleCheckValidator()).validate(bills);
	}
	private List<String> checkOrgCtrl() {
		List<String> list = new ArrayList<>();
		String strWhere = " pk_defdoclist in (select pk_defdoclist from bd_defdoclist where code='org-ctrl' and dr=0 )  and dr=0";
		try {
			DefdocVO[] defdocVOs = (DefdocVO[]) new HYSuperDMO().queryByWhereClause(DefdocVO.class, strWhere);
			if (defdocVOs != null && defdocVOs.length > 0) {
				for (DefdocVO defdocVO : defdocVOs) {
					list.add(defdocVO.getCode());
				}
			}
		} catch (DAOException e) {
			e.printStackTrace();
		}
		return list;
	}
}
